#ifndef	LIBQDISPLAY_H
#define	LIBQDISPLAY_H

#include "./init.h"

/* ============================================================================ */

#ifdef	LIBQDISPLAY_CORE
#include "./libqtools.h"
#include "../libqdisplay/3d.h"
#include "../libqdisplay/cache.h"
#include "../libqdisplay/clippoly.h"
#include "../libqdisplay/display.h"
#include "../libqdisplay/draw.h"
#include "../libqdisplay/render.h"
#include "../libqdisplay/surface.h"
#include "../libqdisplay/tables.h"
#include "../libqdisplay/tbsp.h"
#endif

#include "./mathlib.h"

#define	DISPLAY_TEXTURED	0
#define	DISPLAY_FLAT		1
#define	DISPLAY_WIRE		2

bool DisplayBSP(__memBase, char *Title, int width, int height, int depth, int display, bool wait);
bool DisplayPicture(void *pic, char *Title, int width, int height, int depth, bool wait);
void DisplayEnd(void);

#endif
